//+------------------------------------------------------------------+
//| Collaboration: Dolly + Isakas + Nina System (DIN)                |
//|                                             KusKus_EA.mq4        |
//|                                              Copyright  2007    |
//|    Written by Robert Hill for Forex-tsd group                    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Robert Hill"
#property link      "http://www.forex-tsd.com/"
#include <stdlib.mqh>

#define UP 1
#define DOWN 2
// Trend indicators
#define NO_FILTER 0
#define MACD_FILTER 1
#define EMA_FILTER 2
#define LSMA_FILTER 3
#define ITREND_FILTER 4
#define HMA_FILTER 5


//+---------------------------------------------------+
//|Account functions                                  |
//+---------------------------------------------------+
extern bool AccountIsMini = true;      // Change to true if trading mini account
//+---------------------------------------------------+
//|Money Management                                   |
//+---------------------------------------------------+
extern bool MoneyManagement = true; // Change to false to shutdown money management controls.
                                    // Lots = 1 will be in effect and only 1 lot will be open regardless of equity.
extern double TradeSizePercent = 10;      // Change to whatever percent of equity you wish to risk.
extern double Lots = 0.1;             // standard lot size. 
extern double MaxLots = 100;
//+---------------------------------------------------+
//|Profit controls                                    |
//+---------------------------------------------------+
extern double StopLoss = 30;        // Maximum pips willing to lose per position.
extern bool UseTrailingStop = false;
extern double TrailingStop = 15;    // Change to whatever number of pips you wish to trail your position with.
extern double Margincutoff = 800;   // Expert will stop trading if equity level decreases to that level.
extern int TakeProfit = 15;          // Maximum profit level achieved.
extern int Slippage = 10;           // Possible fix for not getting filled or closed    

//+---------------------------------------------------+
//|Indicator Variables                                |
//| Change these to try your own system               |
//| or add more if you like                           |
//+---------------------------------------------------+

extern string  Expert_Name    = "---- KusKus_EA ----";
extern string  s3="BBandsStop settings";
extern int     Length=20;      // Bollinger Bands Period
extern int     Deviation=2;    // Deviation
extern double  MoneyRisk=1.00; // Offset Factor
extern int     SignalTimeFrame = 30;

extern string dstr0 = " 4 Hr Trend";
extern string dstr1 = " 0 = None";
extern string dstr2 = " 1 = MACD";
extern string dstr3 = " 2 = EMA(14)";
extern string dstr4 = " 3 = LSMA(18)";
extern string dstr5 = " 4 = ITrend(26)";
extern string dstr6 = " 5 = HMA(16)";
extern int TrendD_Method = 5;
extern int TrendD_Period=6;
extern double TrendD_Threshold=20;
extern int TrendD_PrevShift=3;
extern int TrendD_CurShift=1;
extern int TrendD_TimeFrame = 240;
extern int TrendD_SignalCandle = 0;
extern string sD=" 4 Hr GMACD settings";
extern int TD_FastEMA = 8;
extern int TD_SlowEMA = 17;
extern int TD_SignalSMA = 9;

extern string fstr0 = " 1 Hr Trend";
extern string fstr1 = " 0 = None";
extern string fstr2 = " 1 = MACD";
extern string fstr3 = " 2 = EMA(14)";
extern string fstr4 = " 3 = LSMA(18)";
extern string fstr5 = " 4 = ITrend(26)";
extern string fstr6 = " 5 = HMA(16)";
extern int Trend4_Method = 0;
extern int Trend4_Period=6;
extern double Trend4_Threshold=10;
extern int Trend4_PrevShift=3;
extern int Trend4_CurShift=1;
extern int Trend4_TimeFrame = 60;
extern int Trend4_SignalCandle = 0;

extern string s4="//====GMACD settings====//";
extern int T4_FastEMA = 8;
extern int T4_SlowEMA = 17;
extern int T4_SignalSMA = 9;

extern bool UseTradingHours = true;
extern bool TradeAsianMarket = true;
extern int StartHour1 = 0;       // Start trades after time
extern int StopHour1 = 3;      // Stop trading after time
extern bool TradeEuropeanMarket = true;
extern int StartHour2 = 9;       // Start trades after time
extern int StopHour2 = 11;      // Stop trading after time
extern bool TradeNewYorkMarket = false;
extern int StartHour3 = 15;       // Start trades after time
extern int StopHour3 = 17;      // Stop trading after time


//+---------------------------------------------------+
//|General controls                                   |
//+---------------------------------------------------+
string setup;
double lotMM;
int TradesInThisSymbol;
int MagicNumber;
bool YesStop;

//+---------------------------------------------------+
//|  Indicator values for signals and filters         |
//|  Add or Change to test your system                |
//+---------------------------------------------------+
double haOpen, haClose;
double LineMin, LineMid;
double Fish;
double BBStopUp, BBStopDown;

 int SignalCandle = 1;
double  macd_H4, macd_HH4;
double macd_D1, macd_DD1;
double MACurrent, MAPrevious;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   
	MagicNumber = 3000 + func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(Period()); 

   setup="KusKus_EA" + Symbol() + "_" + func_TimeFrame_Val2String(func_TimeFrame_Const2Val(Period()));
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//| The functions from this point to the start function are where    |
//| changes are made to test other systems or strategies.            |
//|+-----------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom Indicators                                                |
//+------------------------------------------------------------------+

//===================================================================
//                                                    EMA_Angle.mq4 
//                                                          jpkfox
//
// You can use this indicator to measure when the EMA angle is
// "near zero". AngleTreshold determines when the angle for the
// EMA is "about zero": This is when the value is between
// [-AngleTreshold, AngleTreshold] (or when the histogram is red).
//   EMAPeriod: EMA period 
//   AngleTreshold: The angle value is "about zero" when it is
//     between the values [-AngleTreshold, AngleTreshold].
//   StartEMAShift: The starting point to calculate the 
//     angle. This is a shift value to the left from the
//     observation point. Should be StartEMAShift > EndEMAShift.
//   StartEMAShift: The ending point to calculate the
//     angle. This is a shift value to the left from the
//     observation point. Should be StartEMAShift > EndEMAShift.
//
//  Return 1 for up OK
//  Return -1 for down OK
//  Return 0 for too flat
//===================================================================
double MA_Angle( int PrevShift, int CurShift, double fPrevMA, double fCurMA)
{
   double fAngle, mFactor;
   string Sym;
   int ShiftDif;
   
   mFactor = 100000.0;
   Sym = StringSubstr(Symbol(),3,3);
   if (Sym == "JPY") mFactor = 1000.0;
   ShiftDif = PrevShift-CurShift;
   mFactor /= ShiftDif; 

    fAngle = mFactor * (fCurMA - fPrevMA)/2.0;

    return(fAngle);
}



//+------------------------------------------------------------------------+
//| LSMA - Least Squares Moving Average function calculation               |
//| LSMA_In_Color Indicator plots the end of the linear regression line    |
//+------------------------------------------------------------------------+

double fLSMA(int TimeFrame, int myRperiod, int shift)
{
   int i;
   double sum;
   int length;
   double lengthvar;
   double tmp;
   double wt;

   length = myRperiod;
 
   sum = 0;
   for(i = length; i >= 1  ; i--)
   {
     lengthvar = length + 1;
     lengthvar /= 3;
     tmp = 0;
     tmp = ( i - lengthvar)*iClose(NULL, TimeFrame,length-i+shift);
     sum+=tmp;
    }
    wt = sum*6/(length*(length+1));
    
    return(wt);
}

bool CheckHeikenAshi(int cmd)
{
   haOpen = iCustom(NULL, SignalTimeFrame, "Heiken_Ashi_Ma",1,15,2,1);
   haClose = iCustom(NULL, SignalTimeFrame, "Heiken_Ashi_Ma",1,15,3,1);
   switch (cmd)
   {
     case OP_BUY : if (haOpen < haClose) return(true);
                   break;
     case OP_SELL : if (haOpen > haClose) return(true);
   }
   
   return(false);
}

bool CheckStepMA(int cmd)
{
   LineMin = iCustom(NULL, SignalTimeFrame, "Hist_StepMA_Stoch_KV1_Ex_03",0,1);
   LineMid = iCustom(NULL, SignalTimeFrame, "Hist_StepMA_Stoch_KV1_Ex_03",1,1);
   switch (cmd)
   {
     case OP_BUY : if (LineMid > 0) return(true);
                   break;
     case OP_SELL : if (LineMin < 0) return(true);
   }
   
   return(false);
}

bool CheckFish(int cmd)
{
   Fish = iCustom(NULL, SignalTimeFrame, "Fisher_m11",35,0.3, 0.3,0,1);
   switch (cmd)
   {
     case OP_BUY : if (Fish > 0) return(true);
                   break;
     case OP_SELL : if (Fish < 0) return(true);
   }
   
   return(false);
}

bool CheckBBStop(int cmd)
{
   BBStopUp = iCustom(NULL, SignalTimeFrame, "BBands_Stop_v2", Length, Deviation, MoneyRisk, 0, 1);
   BBStopDown = iCustom(NULL, SignalTimeFrame, "BBands_Stop_v2", Length, Deviation, MoneyRisk, 1, 1);
   switch (cmd)
   {
     case OP_BUY : if (BBStopUp > 0 ) return(true);
                   break;
     case OP_SELL : if (BBStopDown > 0) return(true);
   }
   
   return(false);
}

void GetMA(int TimeFrame, int MAPeriod, int Prev, int Cur)
{
   MACurrent=iMA(NULL,TimeFrame,MAPeriod,0,MODE_EMA,PRICE_CLOSE,Cur);
   MAPrevious=iMA(NULL,TimeFrame,MAPeriod,0,MODE_EMA,PRICE_CLOSE,Prev);
}

void GetLSMA(int TimeFrame, int MAPeriod, int Prev, int Cur)
{
   MACurrent=fLSMA(TimeFrame,MAPeriod,Cur);
   MAPrevious=fLSMA(TimeFrame,MAPeriod,Prev);
}

void GetITrend(int TimeFrame, int MAPeriod, int Prev, int Cur)
{
   MACurrent=iCustom(NULL,TimeFrame,"Ehlers_iTrend",MAPeriod,0,Cur);
   MAPrevious=iCustom(NULL,TimeFrame,"Ehlers_iTrend",MAPeriod,0,Prev);
}

void GetHMA(int TimeFrame, int MAPeriod, int Prev, int Cur)
{
   MACurrent=iCustom(NULL,TimeFrame,"HMA2",MAPeriod,0,Cur);
   MAPrevious=iCustom(NULL,TimeFrame,"HMA2",MAPeriod,0,Prev);
}

void GetMA_Trend (int TrendMethod, int myTimeFrame, int myPeriod, int PrevShift, int CurShift)
{
   switch (TrendMethod)
   {
     case EMA_FILTER : GetMA(myTimeFrame,  myPeriod, PrevShift, CurShift);
                      break;
     case LSMA_FILTER :  GetLSMA(myTimeFrame,  myPeriod, PrevShift, CurShift);
                         break;
     case ITREND_FILTER : GetITrend(myTimeFrame,  myPeriod, PrevShift, CurShift);
                          break;
     case HMA_FILTER : GetHMA(myTimeFrame,  myPeriod, PrevShift, CurShift);
   }
}

bool CheckTrend(int cmd)
{
   bool H4TrendUP, H4TrendDOWN, D1TrendUP, D1TrendDOWN;
	bool trendD, trend4;
	double maAngle;
   
   H4TrendUP = true;
   H4TrendDOWN = true;
   switch(Trend4_Method)
   {
      case NO_FILTER :
          if (cmd == OP_BUY) H4TrendDOWN = false;
          if (cmd == OP_SELL) H4TrendUP = false;
          break;
      case MACD_FILTER :
          macd_H4=iMACD(NULL,Trend4_TimeFrame,T4_FastEMA,T4_SlowEMA,T4_SignalSMA,PRICE_CLOSE,MODE_MAIN,Trend4_SignalCandle); 
          macd_HH4=iMACD(NULL,Trend4_TimeFrame,T4_FastEMA,T4_SlowEMA,T4_SignalSMA,PRICE_CLOSE,MODE_SIGNAL,Trend4_SignalCandle); 
    
          if (macd_H4 < macd_HH4) H4TrendUP = false;
          if (macd_H4 > macd_HH4) H4TrendDOWN = false;
          break;
      default :
          GetMA_Trend(Trend4_Method, Trend4_TimeFrame, Trend4_Period, Trend4_PrevShift, Trend4_CurShift );
	       maAngle = MA_Angle(Trend4_PrevShift, Trend4_CurShift, MAPrevious, MACurrent);
          switch (cmd)
          {
             case OP_BUY : if (maAngle < Trend4_Threshold) H4TrendUP = false;
                           break;
             case OP_SELL : if (maAngle > -Trend4_Threshold) H4TrendDOWN = false;
          }
   }

   D1TrendUP = true;
   D1TrendDOWN = true;
   switch(TrendD_Method)
   {
      case NO_FILTER :
          if (cmd == OP_BUY) D1TrendDOWN = false;
          if (cmd == OP_SELL) D1TrendUP = false;
          break;
      case MACD_FILTER :
          macd_D1=iMACD(NULL,TrendD_TimeFrame,TD_FastEMA,TD_SlowEMA,TD_SignalSMA,PRICE_CLOSE,MODE_MAIN,TrendD_SignalCandle); 
          macd_DD1=iMACD(NULL,TrendD_TimeFrame,TD_FastEMA,TD_SlowEMA,TD_SignalSMA,PRICE_CLOSE,MODE_SIGNAL,TrendD_SignalCandle);
      
          if (macd_D1 < macd_DD1) D1TrendUP = false;
          if (macd_D1 > macd_DD1) D1TrendDOWN = false;
          break;
      default :
          GetMA_Trend(TrendD_Method, TrendD_TimeFrame, TrendD_Period , TrendD_PrevShift, TrendD_CurShift);
	       maAngle = MA_Angle(TrendD_PrevShift, TrendD_CurShift, MAPrevious, MACurrent);
          switch (cmd)
          {
             case OP_BUY : if (maAngle < TrendD_Threshold) D1TrendUP = false;
                           break;
             case OP_SELL : if (maAngle > -TrendD_Threshold) D1TrendDOWN = false;
          }
   }
          
   switch (cmd)
   {
       case OP_BUY : if (H4TrendUP && D1TrendUP) return(true);
                     break;
       case OP_SELL : if (H4TrendDOWN && D1TrendDOWN) return(true);
   }
    
   return(false);

}

//+------------------------------------------------------------------+
//| CheckExitCondition                                               |
//| Uses OP_BUY as cmd to check exit sell                            |
//| Uses OP_SELL as cmd to check exit buy                            |
//+------------------------------------------------------------------+
bool CheckExitCondition(int cmd)
{
   if (CheckHeikenAshi(cmd))
   {
      if (CheckStepMA(cmd)) return(true);
   }
   return(false);
   
// Maybe add these to check later
   if (CheckFish(cmd)) return(true);
   if(CheckBBStop(cmd))  return(true);
   
   return (false);
}

//+------------------------------------------------------------------+
//| CheckEntryCondition                                              |
//+------------------------------------------------------------------+
bool CheckEntryCondition(int cmd)
{
    
   if (CheckTrend(cmd))
   {
    if (CheckHeikenAshi(cmd))
    {
      if (CheckBBStop(cmd))
      {
        if (CheckFish(cmd))
        {
           if(CheckStepMA(cmd))  return(true);
        }
      }
    }
   }
   
   return (false);
}
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
   
//+------------------------------------------------------------------+
//| Check for Open Position                                          |
//+------------------------------------------------------------------+

     HandleOpenPositions();
     
// Check if any open positions were not closed

     TradesInThisSymbol = CheckOpenPositions();
     
//+------------------------------------------------------------------+
//| Check if OK to make new trades                                   |
//+------------------------------------------------------------------+


   if(AccountFreeMargin() < Margincutoff) {
     return(0);}

   if (UseTradingHours)
   {

     YesStop = true;
// Check trading Asian Market
     if (TradeAsianMarket)
     {
        if (Hour() >= StartHour1 && Hour() <= StopHour1) YesStop = false;
     }
     if (YesStop)
     {
// Check trading European Market
       if (TradeEuropeanMarket)
       {
         if (Hour() >= StartHour2 && Hour() <= StopHour2) YesStop = false;
       }
     }
     if (YesStop)
     {
// Check trading European Market
       if (TradeNewYorkMarket)
       {
         if (Hour() >= StartHour3 && Hour() <= StopHour3) YesStop = false;
       }
     }
     if (YesStop)
     {
//      Comment ("Trading has been stopped as requested - wrong time of day");
       return (0);
      }
   }
     
// Only allow 1 trade per Symbol

     if(TradesInThisSymbol > 0) {
       return(0);}
   

   lotMM = GetLots();
   
      
	if(CheckEntryCondition(OP_BUY))
	{
		   OpenBuyOrder();
		   return(0);
	}

   
	if(CheckEntryCondition(OP_SELL))
	{
         OpenSellOrder();
	}
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Functions beyond this point should not need to be modified       |
//| Eventually will be placed in include file                        |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| OpenBuyOrder                                                     |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenBuyOrder()
{
   int err,ticket, digits;
   double myPrice, myStopLoss = 0, myTakeProfit = 0;
   
   myPrice = MarketInfo(Symbol(), MODE_ASK);
   myStopLoss = 0;
   if ( StopLoss > 0 ) myStopLoss = myPrice - StopLoss * Point ;
   myTakeProfit = 0;
   if (TakeProfit>0) myTakeProfit = myPrice + TakeProfit * Point;
 // Normalize all price / stoploss / takeprofit to the proper # of digits.
   digits = MarketInfo(Symbol( ), MODE_DIGITS) ;
   if (digits > 0) 
   {
     myPrice = NormalizeDouble( myPrice, digits);
     myStopLoss = NormalizeDouble( myStopLoss, digits);
     myTakeProfit = NormalizeDouble( myTakeProfit, digits); 
   }
   ticket=OrderSend(Symbol(),OP_BUY,lotMM,myPrice,Slippage,myStopLoss,myTakeProfit,setup,MagicNumber,0,Green); 
   if (ticket > 0)
   {
    if (OrderSelect( ticket,SELECT_BY_TICKET, MODE_TRADES) ) 
     {
      Print("BUY order opened : ", OrderOpenPrice( ));
//      ModifyOrder(ticket,OrderOpenPrice( ), OrderStopLoss(), myTakeProfit);
    }
   }
   else
   {
      err = GetLastError();
      Print("Error opening BUY order [" + setup + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}

//+------------------------------------------------------------------+
//| OpenSellOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenSellOrder()
{
   int err, ticket, digits;
   double myPrice, myStopLoss = 0, myTakeProfit = 0;
   
   myPrice = MarketInfo(Symbol( ), MODE_BID);
   myStopLoss = 0;
   if ( StopLoss > 0 ) myStopLoss = myPrice + StopLoss * Point;
   myTakeProfit = 0;
   if (TakeProfit > 0) myTakeProfit = myPrice - TakeProfit * Point;
 // Normalize all price / stoploss / takeprofit to the proper # of digits.
   digits = MarketInfo(Symbol( ), MODE_DIGITS) ;
   if (digits > 0) 
   {
     myPrice = NormalizeDouble( myPrice, digits);
     myStopLoss = NormalizeDouble( myStopLoss, digits);
     myTakeProfit = NormalizeDouble( myTakeProfit, digits); 
   }
   ticket=OrderSend(Symbol(),OP_SELL,lotMM,myPrice,Slippage,myStopLoss,myTakeProfit,setup,MagicNumber,0,Red); 
   if (ticket > 0)
   {
     if (OrderSelect( ticket,SELECT_BY_TICKET, MODE_TRADES) ) 
     {
      Print("Sell order opened : ", OrderOpenPrice());
//      ModifyOrder(ticket,OrderOpenPrice( ), OrderStopLoss(), myTakeProfit);
     }
   }
   else
   {
      err = GetLastError();
      Print("Error opening Sell order [" + setup + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}

//+------------------------------------------------------------------+
//| Check Open Position Controls                                     |
//+------------------------------------------------------------------+
  
int CheckOpenPositions()
{
   int cnt, total, NumPositions;
   int NumBuyTrades, NumSellTrades;   // Number of buy and sell trades in this symbol
   
   NumBuyTrades = 0;
   NumSellTrades = 0;
   total=OrdersTotal();
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
     {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      
      if(OrderType() == OP_BUY )  NumBuyTrades++;
      if(OrderType() == OP_SELL ) NumSellTrades++;
             
     }
     NumPositions = NumBuyTrades + NumSellTrades;
     return (NumPositions);
  }

int CloseOrder(int ticket,double numLots,int cmd)
{
   int CloseCnt, err, digits;
   double myPrice;
   
   if (cmd == OP_BUY) myPrice = MarketInfo(Symbol( ), MODE_BID);
   if (cmd == OP_SELL) myPrice = MarketInfo(Symbol( ), MODE_ASK);
   digits = MarketInfo(Symbol( ), MODE_DIGITS) ;
   if (digits > 0)  myPrice = NormalizeDouble( myPrice, digits);
   // try to close 3 Times
      
    CloseCnt = 0;
    while (CloseCnt < 3)
    {
       if (!OrderClose(ticket,numLots,myPrice,Slippage,Violet))
       {
         err=GetLastError();
         Print(CloseCnt," Error closing order : (", err , ") " + ErrorDescription(err));
         if (err > 0) CloseCnt++;
       }
       else
       {
         CloseCnt = 3;
       }
    }
}

int ModifyOrder(int ord_ticket,double op, double price,double tp)
{
    int CloseCnt, err;
    
    CloseCnt=0;
    while (CloseCnt < 3)
    {
       if (OrderModify(ord_ticket,op,price,tp,0,Aqua))
       {
         CloseCnt = 3;
       }
       else
       {
          err=GetLastError();
          Print(CloseCnt," Error modifying order : (", err , ") " + ErrorDescription(err));
         if (err>0) CloseCnt++;
       }
    }
}

//+------------------------------------------------------------------+
//| HandleTrailingStop                                               |
//| Type 1 moves the stoploss without delay.                         |
//| Type 2 waits for price to move the amount of the trailStop       |
//| before moving stop loss then moves like type 1                   |
//| Type 3 uses up to 3 levels for trailing stop                     |
//|      Level 1 Move stop to 1st level                              |
//|      Level 2 Move stop to 2nd level                              |
//|      Level 3 Trail like type 1 by fixed amount other than 1      |
//| Possible future types                                            |
//| Type 4 uses 2 for 1, every 2 pip move moves stop 1 pip           |
//| Type 5 uses 3 for 1, every 3 pip move moves stop 1 pip           |
//+------------------------------------------------------------------+
int HandleTrailingStop(int type, int ticket, double op, double os, double tp)
{
    int digits;
    double pt, TS;
    double myPrice;
    
    digits = MarketInfo(Symbol( ), MODE_DIGITS) ;
    if (type == OP_BUY)
    {
        myPrice = MarketInfo(Symbol( ), MODE_BID);
        pt = Point*TrailingStop;
        TS = myPrice - pt;
 // Normalize all price / stoploss / takeprofit to the proper # of digits.
        if (digits > 0) TS = NormalizeDouble( TS, digits);
        if(myPrice-op > pt && os < TS) ModifyOrder(ticket,op,TS,tp);
        return(0);
    }
       
    if (type ==  OP_SELL)
    {
        myPrice = MarketInfo(Symbol( ), MODE_ASK);
        pt = Point*TrailingStop;
        TS = myPrice + pt;
 // Normalize all price / stoploss / takeprofit to the proper # of digits.
        if (digits > 0) TS = NormalizeDouble(TS, digits); 
        if(op - myPrice > pt && os > TS) ModifyOrder(ticket,op,TS,tp);
    }
    return(0);
}


//+------------------------------------------------------------------+
//| Handle Open Positions                                            |
//| Check if any open positions need to be closed or modified        |
//+------------------------------------------------------------------+
int HandleOpenPositions()
{
   int cnt;
   
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      
      if(OrderType() == OP_BUY)
      {
            
         if (CheckExitCondition(OP_SELL))
          {
              CloseOrder(OrderTicket(),OrderLots(),OP_BUY);
          }
          else
          {
            if (UseTrailingStop)
            {
               HandleTrailingStop(OP_BUY,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
            }
          }
      }

      if(OrderType() == OP_SELL)
      {
          if (CheckExitCondition(OP_BUY))
          {
             CloseOrder(OrderTicket(),OrderLots(),OP_SELL);
          }
          else
          {
            if (UseTrailingStop)
            {
               HandleTrailingStop(OP_SELL,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
            }
          }
      }
   }
}

     
//+------------------------------------------------------------------+
//| Get number of lots for this trade                                |
//+------------------------------------------------------------------+
double GetLots()
{
   double lot;
   
   if(MoneyManagement)
   {
     lot = LotsOptimized();
   }
   else
   {
     lot = Lots;
   }
   
   if(AccountIsMini)
   {
     if (lot < 0.1) lot = 0.1;
   }
   else
   {
     if (lot >= 1.0) lot = MathFloor(lot); else lot = 1.0;
   }
   if (lot > MaxLots) lot = MaxLots;
   
   return(lot);
}

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+

double LotsOptimized()
  {
   double lot=Lots;
//---- select lot size
   lot=NormalizeDouble(MathFloor(AccountFreeMargin()*TradeSizePercent/10000)/10,1);
   
  
  // lot at this point is number of standard lots
  
//  if (Debug) Print ("Lots in LotsOptimized : ",lot);
  
  // Check if mini or standard Account
  
  if(AccountIsMini)
  {
    lot = MathFloor(lot*10)/10;
    
   }
   return(lot);
  }

//+------------------------------------------------------------------+
//| Time frame interval appropriation  function                      |
//+------------------------------------------------------------------+

int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}

//+------------------------------------------------------------------+
//| Time frame string appropriation  function                               |
//+------------------------------------------------------------------+

string func_TimeFrame_Val2String(int Value ) {
   switch(Value) {
      case 1:  // M1
         return("PERIOD_M1");
      case 2:  // M1
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " + Value);
   }
}

int func_Symbol2Val(string symbol)
 {
   string mySymbol = StringSubstr(symbol,0,6);
	if(mySymbol=="AUDCAD") return(1);
	if(mySymbol=="AUDJPY") return(2);
	if(mySymbol=="AUDNZD") return(3);
	if(mySymbol=="AUDUSD") return(4);
	if(mySymbol=="CHFJPY") return(5);
	if(mySymbol=="EURAUD") return(6);
	if(mySymbol=="EURCAD") return(7);
	if(mySymbol=="EURCHF") return(8);
	if(mySymbol=="EURGBP") return(9);
	if(mySymbol=="EURJPY") return(10);
	if(mySymbol=="EURUSD") return(11);
	if(mySymbol=="GBPCHF") return(12);
	if(mySymbol=="GBPJPY") return(13);
	if(mySymbol=="GBPUSD") return(14);
	if(mySymbol=="NZDUSD") return(15);
	if(mySymbol=="USDCAD") return(16);
	if(mySymbol=="USDCHF") return(17);
	if(mySymbol=="USDJPY") return(18);
   Comment("unexpected Symbol");
	return(19);
}

